import {select,forceSimulation,forceManyBody,forceLink,forceCenter} from 'd3';

const nodes = [], links = []; //initialize variables

//the following is the function that adds a node to main node.
const addMainNode = (node) => {
  node.size = 35; //this size is used to design and disple the size of main node
  nodes.push(node);
};
//the following is the function that gets parent and child nodes and create link between them.
const addChildNode = (parentNode, childNode) => {
  childNode.size = 20; //this size is used to design and disple the size of child node
  nodes.push(childNode);
  links.push({ source: parentNode, target: childNode });
};
//the following are the nodes
const me = { id: 'Platini' };
const asongtia = { id: 'Asongtia' };
const yannick = { id: 'Yannick' };
const guy = { id: 'Guy' };
const gerard = { id: 'Gerard' };
const sylvain = { id: 'Sylvain' };
const joel = { id: 'Joel' };
//the following calls the functions to create link between nodes
addMainNode(me);  //calls function to assign a main node
addChildNode(me, asongtia); //passes 2 nodes to function to create link between them
addChildNode(me, yannick); //passes 2 nodes to function to create link between them
addChildNode(me, gerard); //passes 2 nodes to function to create link between them
addChildNode(me, sylvain); //passes 2 nodes to function to create link between them
addChildNode(me, joel); //passes 2 nodes to function to create link between them
addChildNode(me, guy); //passes 2 nodes to function to create link between them
addChildNode(asongtia, guy); //passes 2 nodes to function to create link between them
addChildNode(gerard, joel); //passes 2 nodes to function to create link between them

const svg = select('svg'); //get the svg whose id is network
const width = +svg.attr('width'); //get width of svg
const height = +svg.attr('height'); //get height of svg
const centerX = width / 2, centerY = height / 2; //find the center of svg

// create a simulation by positioning the links and nodes  
const simulation = forceSimulation(nodes)
  .force('charge', forceManyBody().strength(-2000))
  .force('link', forceLink(links))
  .force('center', forceCenter(centerX, centerY));

// create the circle for the nodes according to its size and append to svg and fill the color
const circles = svg.selectAll('circle').data(nodes).enter().append('circle')
										.attr('fill', 'gold')
  .attr('r', (node) => node.size);
// add the names of the nodes in the middle and append to svg and fill the color
const text = svg.selectAll('text').data(nodes).enter().append('text')
									.attr('text-anchor', 'middle').
	attr('alignment-baseline', 'middle').text((node) => node.id);
//create the line from the link data and fill the line with the given color and append to
// the svg
const lines = svg.selectAll('line').data(links).enter().append('line')
									.attr('stroke', 'gold');

simulation.on('tick', () => {
  // add the circles to the simulation
  circles.attr('cx', (node) => node.x).attr('cy', (node) => node.y); 
   // add names to the simulation
  text.attr('x', (node) => node.x).attr('y', (node) => node.y);  

  // generate line between the 2 coordinates
  lines
    .attr('x1', (link) => link.source.x)
    .attr('y1', (link) => link.source.y)
    .attr('x2', (link) => link.target.x)
    .attr('y2', (link) => link.target.y);
});